package org.seasar.webwork.nazo;

import com.opensymphony.xwork.ObjectFactory;
import com.opensymphony.xwork.config.ConfigurationManager;
import com.opensymphony.xwork.config.entities.PackageConfig;
import javax.servlet.ServletContext;
import org.jmock.Mock;
import org.jmock.MockObjectTestCase;
import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.impl.S2ContainerImpl;

public class NazoWebWorkConfigurerTest extends MockObjectTestCase {

    public void testInit() throws Exception {
	PackageConfig packageConfig = new PackageConfig("nazo", "", true, null);
	ConfigurationManager.getConfiguration().addPackageConfig(packageConfig.getName(), packageConfig);

	S2Container childContainer = new S2ContainerImpl();
	childContainer.register("childContainer");
	S2Container parentContainer = new S2ContainerImpl();
	parentContainer.register("parentContainer");
	parentContainer.include(childContainer);

	Mock servletContextMock = mock(ServletContext.class);
	servletContextMock.expects(once()).method("getResourceAsStream").with(eq("/WEB-INF/nazo/testAction.groovy")).will(returnValue(null));
	parentContainer.setServletContext((ServletContext) servletContextMock.proxy());

	NazoWebWorkConfigurer nazoWebWorkConfigurer = new NazoWebWorkConfigurer();
	nazoWebWorkConfigurer.init(childContainer);

	assertTrue(ObjectFactory.getObjectFactory() instanceof S2NazoObjectFactory);
	assertEquals("parentContainer", ObjectFactory.getObjectFactory().buildBean(String.class));

	assertTrue(ConfigurationManager.getConfiguration() instanceof ConfigurationImpl);
	assertNull(ConfigurationManager.getConfiguration().getRuntimeConfiguration().getActionConfig("", "testAction"));
    }
}
