package org.seasar.webwork.nazo;

import com.opensymphony.xwork.config.ConfigurationManager;
import com.opensymphony.xwork.config.entities.PackageConfig;
import com.opensymphony.xwork.config.entities.ResultConfig;
import java.util.Collections;
import java.util.Map;
import junit.framework.TestCase;

public class ResultConfigMapTest extends TestCase {

    public void testGet() {
	PackageConfig defaultPackageConfig = ConfigurationManager.getConfiguration().getPackageConfig("webwork-default");
	PackageConfig packageConfig = new PackageConfig("nazo", "", true, null, Collections.singletonList(defaultPackageConfig));
	ConfigurationManager.getConfiguration().addPackageConfig(packageConfig.getName(), packageConfig);

	Map map = new ResultConfigMap("testActionName");
	Object value = map.get("testResultCode");
	assertTrue(value instanceof ResultConfig);

	ResultConfig resultConfig = (ResultConfig) value;
	assertEquals("com.opensymphony.webwork.dispatcher.VelocityResult", resultConfig.getClassName());
	assertEquals("testResultCode", resultConfig.getName());
	assertEquals("/WEB-INF/nazo/testActionName_testResultCode.vm", resultConfig.getParams().get("location"));
    }
}
